//+------------------------------------------------------------------+
//|                                                           rsioma |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    7
#property indicator_color1     LimeGreen
#property indicator_color2     DarkGray
#property indicator_color3     Red
#property indicator_color4     LimeGreen
#property indicator_color5     Red
#property indicator_color6     Red
#property indicator_color7     Gold
#property indicator_width4     2
#property indicator_width5     2
#property indicator_width6     2
#property indicator_style1     STYLE_DOT
#property indicator_style2     STYLE_DOT
#property indicator_style3     STYLE_DOT
#property indicator_style7     STYLE_DOT
#property indicator_levelcolor MediumOrchid
#import "dynamicZone.dll"
   double dzBuy(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i );
   double dzSell(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i );
#import

//
//
//
//
//

extern string TimeFrame         = "Current time frame";
extern int    RsiMethod         = 2;
extern int    RsiOma_Period     = 14;
extern int    RsiOma_Price      = 0;
extern int    RsiOma_PriceShift = 0;
extern double Oma_Speed         = 3;
extern bool   Oma_Adaptive      = true;
extern int    MaPeriod          = 10;
extern int    MaType            = MODE_LWMA;
extern int    DzLookBackBars    = 35;
extern double DzBuyProbability  = 0.20;
extern double DzSellProbability = 0.20;
extern bool   arrowsVisible     = false;
extern string arrowsIdentifier  = "RsiomaArrows1";
extern color  arrowsUpColor     = DeepSkyBlue;
extern color  arrowsDnColor     = Red;
extern double arrowsUpperGap    = 0.75;
extern double arrowsLowerGap    = 0.75;

extern string note                = "turn on Alert = true; turn off = false";
extern bool   alertsOn            = false;
extern bool   alertsOnMaCross     = true;
extern bool   alertsOnSlopeChange = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;
extern string soundfile           = "alert2.wav";
extern bool   Interpolate         = true;

//
//
//
//
//

double rsi[];
double rsida[];
double rsidb[];
double ma[];
double dzu[];
double dzm[];
double dzd[];
double slope[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
  IndicatorBuffers(8);
    SetIndexBuffer(0,dzu);
    SetIndexBuffer(1,dzm);
    SetIndexBuffer(2,dzd);
    SetIndexBuffer(3,rsi);
    SetIndexBuffer(4,rsida);
    SetIndexBuffer(5,rsidb);
    SetIndexBuffer(6,ma);
    SetIndexBuffer(7,slope);
    
       //
       //
       //
       //
       //
     
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
 
   IndicatorShortName(timeFrameToString(timeFrame)+" "+getRsiName(RsiMethod)+" Ma ("+RsiOma_Period+","+MaPeriod+")");
return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double trend[];
int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { dzu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArraySize(trend)!=Bars) ArrayResize(trend,Bars);
      if (slope[limit] == -1) ClearPoint(limit,rsida,rsidb);
      for (i=limit; i >= 0; i--) rsi[i] = iRsi(iOma(iMA(NULL,0,1,0,MODE_SMA,RsiOma_Price,i+RsiOma_PriceShift),RsiOma_Period,Oma_Speed,Oma_Adaptive,i),RsiOma_Period,RsiMethod,i);
      for (i=limit, r = Bars-i-1; i >= 0; i--,r++)
      {
        dzu[i] = dzBuy (rsi, DzBuyProbability,  DzLookBackBars, Bars, i);
        dzd[i] = dzSell(rsi, DzSellProbability, DzLookBackBars, Bars, i);
        dzm[i] = dzSell(rsi, 0.5              , DzLookBackBars, Bars, i);
        ma[i]  = iMAOnArray(rsi,0,MaPeriod,0,MaType,i);
        rsida[i] = EMPTY_VALUE;
        rsidb[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
        trend[r] = trend[r-1]; 
         
	     if (rsi[i] > rsi[i+1]) slope[i]= 1; 
	     if (rsi[i] < rsi[i+1]) slope[i]=-1;
	     if (rsi[i] > ma[i])    trend[r]= 1; 
	     if (rsi[i] < ma[i])    trend[r]=-1;
	     if (slope[i] == -1) PlotPoint(i,rsida,rsidb,rsi);
	        manageArrow(i);
      }
      manageAlerts();  
      return(0);
   }
    
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (slope[limit]==-1) ClearPoint(limit,rsida,rsidb);
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
           dzu[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiMethod,RsiOma_Period,RsiOma_Price,RsiOma_PriceShift,Oma_Speed,Oma_Adaptive,MaPeriod,MaType,DzLookBackBars,DzBuyProbability,DzSellProbability,arrowsVisible,arrowsIdentifier,arrowsUpColor,arrowsDnColor,arrowsUpperGap,arrowsLowerGap,"",alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,0,y);
           dzm[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiMethod,RsiOma_Period,RsiOma_Price,RsiOma_PriceShift,Oma_Speed,Oma_Adaptive,MaPeriod,MaType,DzLookBackBars,DzBuyProbability,DzSellProbability,arrowsVisible,arrowsIdentifier,arrowsUpColor,arrowsDnColor,arrowsUpperGap,arrowsLowerGap,"",alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,1,y);
           dzd[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiMethod,RsiOma_Period,RsiOma_Price,RsiOma_PriceShift,Oma_Speed,Oma_Adaptive,MaPeriod,MaType,DzLookBackBars,DzBuyProbability,DzSellProbability,arrowsVisible,arrowsIdentifier,arrowsUpColor,arrowsDnColor,arrowsUpperGap,arrowsLowerGap,"",alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,2,y);
           rsi[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiMethod,RsiOma_Period,RsiOma_Price,RsiOma_PriceShift,Oma_Speed,Oma_Adaptive,MaPeriod,MaType,DzLookBackBars,DzBuyProbability,DzSellProbability,arrowsVisible,arrowsIdentifier,arrowsUpColor,arrowsDnColor,arrowsUpperGap,arrowsLowerGap,"",alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,3,y);
           rsida[i] = EMPTY_VALUE;
           rsidb[i] = EMPTY_VALUE;
           ma[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiMethod,RsiOma_Period,RsiOma_Price,RsiOma_PriceShift,Oma_Speed,Oma_Adaptive,MaPeriod,MaType,DzLookBackBars,DzBuyProbability,DzSellProbability,arrowsVisible,arrowsIdentifier,arrowsUpColor,arrowsDnColor,arrowsUpperGap,arrowsLowerGap,"",alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,6,y);
           slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiMethod,RsiOma_Period,RsiOma_Price,RsiOma_PriceShift,Oma_Speed,Oma_Adaptive,MaPeriod,MaType,DzLookBackBars,DzBuyProbability,DzSellProbability,arrowsVisible,arrowsIdentifier,arrowsUpColor,arrowsDnColor,arrowsUpperGap,arrowsLowerGap,"",alertsOn,alertsOnMaCross,alertsOnSlopeChange,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,7,y);  
            
          //
          //
          //
          //
          //
       
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int x = 1; x < n; x++)
             {
                dzu[i+x] = dzu[i] + (dzu[i+n] - dzu[i]) * x/n;
                dzm[i+x] = dzm[i] + (dzm[i+n] - dzm[i]) * x/n;
                dzd[i+x] = dzd[i] + (dzd[i+n] - dzd[i]) * x/n;
                rsi[i+x] = rsi[i] + (rsi[i+n] - rsi[i]) * x/n;
                ma[i+x]  = ma[i]  + (ma[i+n]  - ma[i])  * x/n;
             }               
   }
   for (i=limit;i>=0;i--) if (slope[i]==-1) PlotPoint(i,rsida,rsidb,rsi);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible )
   {
         string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
         if (trend[Bars-i-1]!=trend[Bars-i-2])
         {
            if (trend[Bars-i-1] == 1) drawArrow(i,arrowsUpColor,241,false);
            if (trend[Bars-i-1] ==-1) drawArrow(i,arrowsDnColor,242,true);
         }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap*arrowsUpperGap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap*arrowsLowerGap);
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][7];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string rsiMethodNames[] = {"rsi","Wilders rsi","rsx","Cuttler RSI"};
string getRsiName(int& method)
{
   int max = ArraySize(rsiMethodNames)-1;
      method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}

//
//
//
//
//

double workRsi[][13];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int rsiMode, int i, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*13; 
      int r = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[r][z+_price] = price;
   switch (rsiMode)
   {
      case 0:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
         
      //
      //
      //
      //
      //
      
      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,instanceNo*2+0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,instanceNo*2+1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      //
      //
      //
      //
      //

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); }  

         //
         //
         //
         //
         //
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);
            
      //
      //
      //
      //
      //
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
   } 
   return(0);
}

//
//
//
//
//
//

double workSmma[][2];
double iSmma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);

   //
   //
   //
   //
   //

   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      static string   type1 = "";
      static datetime time1 = 0;
      if (alertsOnMaCross && trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(type1,time1,"crossed ma up");
         if (trend[whichBar] ==-1) doAlert(type1,time1,"crossed ma down");
      }         
      static string   type2 = "";
      static datetime time2 = 0;
      if (alertsOnSlopeChange && slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(type2,time2,"changed slope to up");
         if (slope[whichBar] ==-1) doAlert(type2,time2,"changed slope to down");
      }         
   }
}   

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(Period())+" rsioma ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rsioma "),message);
          if (alertsSound)   PlaySound(soundfile);
   }
}